/*
 * The MIT License
 *
 * Copyright 2013 Dra0211.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package kinugasa.game;

import java.io.Serializable;
import kinugasa.contents.resource.Nameable;

/**
 * ウインドウを閉じた際の判定機能を定義します.
 * <br>
 * クローズイベントはウインドウを閉じた際に実行されるイベントです。<br>
 * このイベントは名前および優先度を持ちます。名前は重複してはなりません。<br>
 * 優先度は、イベントが実行されるときに参照され、ソートされます。優先度の値が高いイベントが
 * 先に実行されます。<br>
 * あるイベントが”ゲームを終了しない”という判定をした場合、それ以降のイベントは実行されません。<br>
 * <br>
 * @version 1.0.0 - 2013/04/20_17:36:30<br>
 * @author Dra0211<br>
 */
public abstract class WindowCloseEvent implements Nameable, Comparable<WindowCloseEvent>, Serializable {

	private static final long serialVersionUID = 1518579368912928490L;
	/** このイベントの名前です. */
	private String name;
	/** このイベントの優先度です. */
	private int priority;

	/**
	 * 優先度0のクローズイベントを作成します.
	 * @param name イベントの一意的な名前を指定します。<br>
	 */
	public WindowCloseEvent(String name) {
		this(name, 0);
	}

	/**
	 * 新しいクローズイベントを作成します.
	 * @param name イベントの一意的な名前を指定します。<br>
	 * @param priority このイベントの優先度を指定します。<br>
	 */
	public WindowCloseEvent(String name, int priority) {
		this.name = name;
		this.priority = priority;
	}

	@Override
	public String getName() {
		return name;
	}

	/**
	 * このイベントの優先度を取得します.
	 * @return イベントの優先度を返します。<br>
	 */
	public int getPriority() {
		return priority;
	}

	/**
	 * このイベントの優先度を設定します.
	 * @param priority イベントの優先度を送信します。<br>
	 */
	public void setPriority(int priority) {
		this.priority = priority;
	}

	/**
	 * ウインドウを閉じる際の判定を行います.
	 * @return ウインドウを閉じる場合はtrue、閉じない場合はfalseを返します。
	 * 追加されている全てのウインドウクローズイベントがtrueを返すと、
	 * ウインドウが閉じられ、ゲームが終了します。<br>
	 */
	public abstract boolean close();

	@Override
	public int compareTo(WindowCloseEvent t) {
		return t.priority - this.priority;
	}

	@Override
	public int hashCode() {
		int hash = 3;
		hash = 67 * hash + (this.name != null ? this.name.hashCode() : 0);
		return hash;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		final WindowCloseEvent other = (WindowCloseEvent) obj;
		if ((this.name == null) ? (other.name != null) : !this.name.equals(other.name)) {
			return false;
		}
		return true;
	}

	@Override
	public String toString() {
		return "WindowCloseEvent{" + "name=" + name + ", priority=" + priority + '}';
	}
}